# encoding: utf-8

module Settings
  #
  #
  #
  class Yaml
    #
    #
    #
    def self.load(path = nil)
      path ||= '../configs/default.yml'
      new(path)
    end

    #
    #
    #
    attr_reader :data

    private

    def initialize(path)
      @path = File.absolute_path(path)
      begin
        @data = YAML.load_file(@path)
      rescue Errno::ENOENT
        msg = "file with path: #{@path} not found!"
        raise FileNotFound, msg
      end
    end

    # file path
    attr_reader :path

    #
    # This is supposed to be raised when file transerred to the self.load
    # method wasn't found.
    #
    class FileNotFound < StandardError; end
  end # class Settings::YAML
end # module Settings
